SystemOrganization addCategory: #'Spec-Core'!
SystemOrganization addCategory: #'Spec-Core-Specs'!

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

DialogWindow subclass: #SpecDialogWindow
	instanceVariableNames: 'toolbar specWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecDialogWindow commentStamp: '<historical>' prior: 0!
A SpecDialogWindow is a window made for embedding Spec models into dialog windows
!

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:09'!
cancelAction: aBlock

	self toolbar cancelAction: aBlock ! !

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 15:58'!
cancelled

	^ toolbar cancelled! !

!SpecDialogWindow methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:13'!
giveFocusToNextFrom: aMorph 

	^ self model giveFocusToNextFrom: aMorph ! !

!SpecDialogWindow methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:13'!
giveFocusToPreviousFrom: aMorph 

	^ self model giveFocusToPreviousFrom: aMorph ! !

!SpecDialogWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 6/26/2012 02:33'!
initialExtent 

	^ self model
		ifNotNil: [:m | m initialExtent ]! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/26/2012 02:25'!
newButtonRow

	^ self toolbar buildWithSpec! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/26/2012 02:10'!
newContentMorph
	"Answer a new content morph."

	^ self specWidget
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:08'!
okAction: aBlock

	self toolbar okAction: aBlock ! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/26/2012 02:10'!
specWidget
	^ specWidget! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 14:11'!
specWidget: anObject
	specWidget := anObject.! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/26/2012 02:31'!
toolbar

	^ toolbar ifNil: [ toolbar := OkCancelToolbar owner: self ]! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 14:11'!
toolbar: anObject
	toolbar := anObject.
	self focusOrder 
		removeAll;
		add: self model;
		add: self toolbar ! !

!Dictionary methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ DictionaryValueHolder contents: self! !

Model subclass: #ComposableModel
	instanceVariableNames: 'bindings focusOrder owner window spec extentHolder needRebuild isEventForNextFocusBlock isEventForPreviousFocusBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

!ComposableModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:35'!
defaultSpec

	^ self subclassResponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: ''!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:13'!
specSelectors
	
	^ (((SpecPragmaCollector behavior: self class)
		filter: [:prg | prg keyword = #spec])
		reset;
		collected)
		collect: [:e | e method selector ]! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:39'!
windowSpec

	^{ #StandardWindow.
			#addMorphBack:.	{ self defaultSpec .
						#layout:. {#FrameLayout.
							#fractions:offsets:. (0@0 corner: 1@1). nil	}}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: ''!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/9/2012 16:13'!
addAll: aWindow withSpecLayout: aSpec

	aWindow
		addMorph: (self buildWithSpecLayout: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'StephaneDucasse 5/17/2012 19:26'!
beginsWith: aString fromList: aMorph
	"This method is used bu the list for the search of elements when you are typing directly in the list"
	
	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:31'!
bindings

	^ bindings! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:50'!
bindings: aBindings

	self bindings bindings: aBindings! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:56'!
buildWithSpec
	"Build the widget using the default spec"
	
	^ self buildWithSpec: self defaultSpecSelector! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/9/2012 14:07'!
buildWithSpec: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ widget := SpecInterpreter buildMorphFor: self withSpec: aSpec ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/9/2012 16:12'!
buildWithSpecLayout: aSpecLayout
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ widget := SpecInterpreter new interpretASpec: aSpecLayout model: self ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/11/2012 09:59'!
createInstanceFor: aClassSymbol
	| class |
	
	class := self resolveSymbol: aClassSymbol.
	^ self instantiate: class.! !

!ComposableModel methodsFor: 'specs' stamp: 'bvr 6/1/2012 17:12'!
defaultSpec

	^ self class perform: self defaultSpecSelector! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/26/2012 00:14'!
defaultSpecSelector
	
	((((SpecPragmaCollector behavior: self class class)
		filter: [:prg | prg keyword = 'spec:' and: [prg arguments includes: #default]])
		reset;
		collected)
		collect: [:e | e method selector ])
		ifNotEmpty: [:col | ^ col first ].


	self specSelectors
		ifNotEmpty: [:col | col size = 1 ifTrue: [ ^ col first ]].
		
	"should use pragmas"
	^ #defaultSpec
	
! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/3/2012 17:45'!
delete

	self widget
		ifNotNil: [:widget | window 
						ifNil: [ widget delete ]
						ifNotNil: [:o | o delete ]]! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ ''! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ ''! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:18'!
extent

	^  extentHolder contents! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:18'!
extent: aPoint

	^  extentHolder contents: aPoint! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					next takeKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ false ].
			next takeKeyboardFocus.
			true ]
		ifNotNil: [ 
			owner giveFocusToNextFrom: self.
			true ]! !

!ComposableModel methodsFor: 'private-focus' stamp: 'BenjaminVanRyseghem 6/12/2012 19:28'!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					previous takeLastKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ ^ false ].
			next takeLastKeyboardFocus.
			true]
		ifNotNil: [ 
			owner giveFocusToPreviousFrom: self.
			true ]! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/26/2012 00:32'!
heightToDisplayInTree: aTree
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex y ].
	
	self widget ifNil: [ self buildWithSpec ].
	^ self widget heightToDisplayInTree: aTree! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:47'!
hide

	self widget ifNotNil: [:widget |
		(widget respondsTo: #hide) ifTrue: [ widget hide ]].! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
initialize
	"Initialization code for ComposableModel"

	super initialize.

	bindings := BindingsHolder new.
	extentHolder := nil asValueHolder.
	needRebuild := true asValueHolder.
	isEventForNextFocusBlock := [ false ] asValueHolder.
	isEventForPreviousFocusBlock := [ false ] asValueHolder.
	self initializeWidgets.
	self initializePresenter.! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/26/2012 02:28'!
initializeDialogWindow: aWindow! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/26/2012 00:19'!
initializePresenter
	"Used to specify the subwidgets, and/or to bind them together"
	"By default, do not do anything"
	
	extentHolder whenChangedDo: [:ex | 
		self widget ifNotNil: [:widget |
			(widget respondsTo: #extent:)
				ifTrue: [ widget extent: ex ]]].! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:35'!
initializeWidgets
	
	self subclassResponsability! !

!ComposableModel methodsFor: 'instance creation' stamp: ''!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/11/2012 10:05'!
instantiateModels: aCollectionOfPairs

	aCollectionOfPairs pairsDo: [ :k :v |
		self instVarNamed: k asString put: (self createInstanceFor: v)]! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 17:43'!
isDisplayed
	"Return true if the widget is currently displayed on screen"
	
	^ self window notNil and: [ self window isDisplayed ]! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
isEventForNextFocus: aKeyboardEvent
	"Return true if the event provided as argument corresponds to the shortcut used to switch to the next sub-widget"

	^ self isEventForNextFocusBlock cull: aKeyboardEvent! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
isEventForNextFocusBlock

	^ isEventForNextFocusBlock contents ! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForNextFocusBlock: aBlock

	isEventForNextFocusBlock contents: aBlock ! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocus
	
	^ isEventForPreviousFocusBlock contents! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocus: aKeyboardEvent 
	"Return true if the event provided as argument corresponds to the shortcut used to switch to the previous sub-widget"
	
	^ self isEventForPreviousFocusBlock cull: aKeyboardEvent! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:23'!
isEventForPreviousFocusBlock
	
	^ isEventForPreviousFocusBlock contents! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocusBlock: aBlock

	isEventForPreviousFocusBlock contents: aBlock ! !

!ComposableModel methodsFor: 'private-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:26'!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/7/2012 12:26'!
listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph
	"Specify how this object as a list item should be drawn"

	self widget ifNil: [ self buildWithSpec ].
	self widget listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/9/2012 14:00'!
needRebuild

	^ needRebuild contents! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/9/2012 14:00'!
needRebuild: aBoolean

	needRebuild contents: aBoolean! !

!ComposableModel methodsFor: 'private' stamp: ''!
okToChange

	^ owner 
		ifNil: [
			self canDiscardEdits ifTrue: [^ true].
			self changed: #wantToChange.  "Solicit cancel from view"
			^ self canDiscardEdits]
		ifNotNil: [ owner okToChange ]! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:09'!
openDialogWithSpec
	"Build the widget using the default spec and display it into a window"

	^ self openDialogWithSpec: self defaultSpecSelector.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:29'!
openDialogWithSpec: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	window := SpecDialogWindow basicNew.
	window specWidget: (self buildWithSpec: aSpec).
	window initialize.
	window model: self.
	self initializeDialogWindow: window.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:57'!
openWithSpec
	"Build the widget using the default spec and display it into a window"

	^ self openWithSpec: self defaultSpecSelector.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/9/2012 14:14'!
openWithSpec: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifFalse: [ 
			window := StandardWindow new model: self.
			self addAll: window withSpec: aSpec.
			window openInWorld.
			window title: self title.
			self takeKeyboardFocus ]
		ifTrue: [ | sub |
			sub := window submorphs copy.
			window removeAllMorphs.
			sub allButLast do: [:e | window addMorphBack: e ].
			self needRebuild: true.
			self addAll: window withSpec: aSpec ].
		
	
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/9/2012 16:13'!
openWithSpecLayout: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifFalse: [ 
			window := StandardWindow new model: self.
			self addAll: window withSpecLayout: aSpec.
			window openInWorld.
			window title: self title.
			self takeKeyboardFocus ]
		ifTrue: [ | sub |
			sub := window submorphs copy.
			window removeAllMorphs.
			sub allButLast do: [:e | window addMorphBack: e ].
			self needRebuild: true.
			self addAll: window withSpecLayout: aSpec ].
		
	
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
owner: anObject
	
	owner ifNotNil: [owner removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	owner := anObject.! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/11/2012 10:00'!
resolveSymbol: aSymbol

	^ Smalltalk at: aSymbol! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:47'!
show

	self widget ifNotNil: [:widget |
		(widget respondsTo: #show) ifTrue: [ widget show ]].! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:25'!
spec

	^ spec! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:26'!
spec: aSpec

	spec := aSpec! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:58'!
specSelectors
	"Return all the spec names"
	
	^ self class specSelectors! !

!ComposableModel methodsFor: 'private-focus' stamp: 'StephaneDucasse 5/17/2012 17:57'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self widget ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:58'!
title
	"Return the window's title"

	^ self class title! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/24/2012 23:11'!
treeRenderOn: aCanvas bounds: drawBounds color: drawColor font: aFont from: aMorph
	"Specify how this object as a list item should be drawn"

	self widget ifNil: [ self buildWithSpec ].
	self widget treeRenderOn: aCanvas bounds: drawBounds color: drawColor font: aFont from: aMorph! !

!ComposableModel methodsFor: 'private' stamp: ''!
update: aParameter

	self changed: aParameter! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:58'!
updateTitle
	"Update the window title"

	self window
		ifNotNil: [:w | w title: self title ]! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/7/2012 12:25'!
widget

	^ spec
		ifNil: [ nil ]
		ifNotNil: [:s | s instance ]! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 13:37'!
widgetsInitializationArray

	^ #()! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/26/2012 00:34'!
widthToDisplayInList: aList
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex x ].

	self widget ifNil: [ self buildWithSpec ].
	^ self widget widthToDisplayInList: aList! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/26/2012 00:32'!
widthToDisplayInTree: aTree
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex x ].
	
	self widget ifNil: [ self buildWithSpec ].
	^ self widget widthToDisplayInTree: aTree! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 17:47'!
window

	^ window! !

ComposableModel subclass: #DummyComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DummyComposableModel commentStamp: '<historical>' prior: 0!
A DummyComposableModel is a stupid ComposableSpec subclass used to uglyly retrieve the bindings

The bindings should be a class side inst var of SpecInterpreter!

!DummyComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/13/2012 16:35'!
defaultSpec

	^ SpecLayout composed! !

!DummyComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:14'!
initializeWidgets 
	"Absorb"! !

ComposableModel subclass: #DynamicComposableModel
	instanceVariableNames: 'widgets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DynamicComposableModel commentStamp: '<historical>' prior: 0!
A DynamicComposableModel is a model of spec with a dynamic binding for subwidgets!

!DynamicComposableModel methodsFor: 'error handling' stamp: 'BenjaminVanRyseghem 7/9/2012 16:01'!
doesNotUnderstand: aMessage

	^ widgets at: aMessage selector ifAbsent: [ super doesNotUnderstand: aMessage ]! !

!DynamicComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/9/2012 16:18'!
initialize
	"Initialization code for DynamicComposableModel"

	widgets := IdentityDictionary new.
	super initialize.	! !

!DynamicComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/9/2012 16:24'!
instantiateModels: aCollectionOfPairs

	aCollectionOfPairs pairsDo: [ :k :v |
		widgets at: k asSymbol put: (self createInstanceFor: v) ]! !

PragmaCollector subclass: #SpecPragmaCollector
	instanceVariableNames: 'behavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecPragmaCollector class
	instanceVariableNames: 'behavior'!

!SpecPragmaCollector commentStamp: '<historical>' prior: 0!
A SpecPragmaCollector is a specialized PragmaCollector.

Sonce we just want specs defined on class side, we do not have to check the whole system, then to restrain.!

SpecPragmaCollector class
	instanceVariableNames: 'behavior'!

!SpecPragmaCollector class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/20/2012 19:11'!
behavior: behavior

	^ self new
		behavior: behavior;
		yourself! !

!SpecPragmaCollector methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
allPragmas

	^ self allPragmasIn: (self behavior ifNil: [ ^ #() ])! !

!SpecPragmaCollector methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
allPragmasIn: aClass

	^ (Array
		streamContents: [:stream | Pragma
									withPragmasIn: aClass
									do: [:pragma | stream nextPut: pragma ]]) ! !

!SpecPragmaCollector methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:09'!
behavior
	^ behavior! !

!SpecPragmaCollector methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:09'!
behavior: anObject
	behavior := anObject! !

!SpecPragmaCollector methodsFor: 'initializing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
reset
	"reinitialize current system settings"
	self
		noMoreAnnounceWhile: [self collected copy
				do: [:pragma | self removePragma: pragma].
			self allPragmas
				do: [:pragma | self addPragma: pragma]].
	self announce: (PragmaCollectorReset collector: self)! !

!Morph methodsFor: '*Spec-Core' stamp: ''!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

!Morph methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 17:14'!
ensureLayoutAndAddMorph: aMorph

	aMorph layoutFrame
		ifNil: [ aMorph layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: nil ) ].
		
	self addMorph: aMorph ! !

!SequenceableCollection methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ CollectionValueHolder contents: self! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 15:43'!
fractions: fractionsOrNil

	^ self fractions: fractionsOrNil offsets: nil! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: ''!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

Object subclass: #AbstractSpec
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!AbstractSpec commentStamp: '<historical>' prior: 0!
An AbstractSpec is a basic wrapper which describe a spec.

For now it can seems useless, but structural info will be stored thanks to those wrappers!

!AbstractSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:39'!
addAsSubSpecTo: anotherSpec

	anotherSpec addSubSpec: self.! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings

	^ bindings! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings: anObject

	bindings := anObject! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:22'!
classSymbol

	self subclassResponsibility! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
defaultReceiver

	^ Smalltalk at: (self bindings retrieveClassSymbolFor: (self classSymbol))! !

!AbstractSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
initialize
	"Initialization code for AbstractSpec"

	super initialize.

	bindings := BindingsHolder new.! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:20'!
initializeInstance

	^ self defaultReceiver new.! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:19'!
instance

	^ instance ifNil: [ instance := self initializeInstance. ]! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 02:24'!
instance: anObject

	instance := anObject! !

!AbstractSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:42'!
subSpecs

	^ #()! !

AbstractSpec subclass: #ButtonSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ButtonSpec commentStamp: '<historical>' prior: 0!
A ButtonSpec is a spec used to describe a button!

!ButtonSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 02:48'!
classSymbol

	^ #Button! !

AbstractSpec subclass: #CheckboxSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!CheckboxSpec commentStamp: '<historical>' prior: 0!
A CheckboxSpec is a spec used to describe a CheckboxButton and a RadionButton!

!CheckboxSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:10'!
classSymbol

	^ #Checkbox! !

AbstractSpec subclass: #ComposableSpec
	instanceVariableNames: 'subSpecs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ComposableSpec commentStamp: '<historical>' prior: 0!
A ComposableSpec is a spec used to combine other specs!

!ComposableSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 19:43'!
addSubSpec: aSpec

	subSpecs add: aSpec! !

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:42'!
classSymbol

	^ #Panel! !

!ComposableSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/6/2012 18:14'!
initialize
	"Initialization code for ComposableSpec"

	super initialize.

	subSpecs := OrderedCollection new.! !

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/11/2012 10:44'!
initializeInstance

	^ SpecInterpreter
		interpretASpec: 
			{ self classSymbol.
				#useProportionalLayout.
				#addSplitters.
				#vSpaceFill.
				#hSpaceFill.} 
		model: DummyComposableModel new! !

!ComposableSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 19:17'!
subSpecs

	^ subSpecs! !

AbstractSpec subclass: #DropListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DropListSpec commentStamp: '<historical>' prior: 0!
A DropListSpec is a spec to describe a drop list!

!DropListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #DropList! !

AbstractSpec subclass: #LabelSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!LabelSpec commentStamp: '<historical>' prior: 0!
A LabelSpec is a spec used to describe a label!

!LabelSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #Label! !

AbstractSpec subclass: #ListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ListSpec commentStamp: '<historical>' prior: 0!
A ListSpec is a spec used to describe a list!

ListSpec subclass: #IconListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!IconListSpec commentStamp: '<historical>' prior: 0!
An IconListSpec is a spec use to describe a list with icons!

!IconListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #IconList! !

!ListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:21'!
classSymbol

	^ #List! !

ListSpec subclass: #MultiColumnListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!MultiColumnListSpec commentStamp: '<historical>' prior: 0!
A MultiColumnListSpec is a spec used to describe a multi column list!

!MultiColumnListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #MultiColumnList! !

AbstractSpec subclass: #NullObjectSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!NullObjectSpec commentStamp: '<historical>' prior: 0!
A NullObjectSpec is a NullPattern object spec!

!NullObjectSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:40'!
addAsSubSpecTo: anotherSpec
! !

!NullObjectSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:37'!
addSubSpec: anObject
	"absorb the message"! !

AbstractSpec subclass: #RawSpec
	instanceVariableNames: 'defaultReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!RawSpec commentStamp: '<historical>' prior: 0!
A RawSpec is a spec used to describe whatever you want.

It simply works as a stack of interpreted symbols!

!RawSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:40'!
addAsSubSpecTo: anotherSpec
! !

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver

	^ defaultReceiver! !

!RawSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver: anObject

	defaultReceiver := anObject! !

!RawSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:27'!
defaultReceiver: aSymbol model: aModel

	defaultReceiver := SpecInterpreter interpretASpec: aSymbol model: aModel.! !

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:41'!
initializeInstance

	^ self defaultReceiver! !

AbstractSpec subclass: #TextFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextFieldSpec commentStamp: '<historical>' prior: 0!
A TextFieldSpec is a spec used to describe a text field!

!TextFieldSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:16'!
classSymbol

	^ #TextField! !

AbstractSpec subclass: #TextSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextSpec commentStamp: '<historical>' prior: 0!
A TextSpec is a spec used to describe a text area!

!TextSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:53'!
classSymbol

	^ #Text! !

AbstractSpec subclass: #TreeSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TreeSpec commentStamp: '<historical>' prior: 0!
A TreeSpec is a spec used to describe a tree!

!TreeSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:17'!
classSymbol

	^ #Tree! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #CollectionValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!CollectionValueHolder commentStamp: '<historical>' prior: 0!
A CollectionValueHolder is s a value holder designed for collections!

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject

	| result |
	result := contents add: newObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject after: oldObject 
	
	| result |
	result := contents add: newObject after: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject afterIndex: index 
	
	| result |
	result := contents add: newObject afterIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject before: oldObject
	
	| result |
	result := contents add: newObject before: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject beforeIndex: index 
	
	| result |
	result := contents add: newObject beforeIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAll: aCollection 
	
	| result |
	result := contents addAll: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirst: anOrderedCollection
	
	| result |
	result := contents addAllFirst: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirstUnlessAlreadyPresent: anOrderedCollection
	
	| result |
	result := contents addAllFirstUnlessAlreadyPresent: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllLast: aCollection 
	
	| result |
	result := contents addAllLast: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addFirst: newObject 

	| result |
	result := contents addFirst: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addLast: newObject 

	| result |
	result := contents addLast: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index ifAbsentPut: block

	| result |
	result := contents at: index ifAbsentPut: block.
	self contentsChanged: block value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index put: value

	| result |
	result := contents at: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: aCollection put: anObject 
	
	| result |
	result := contents atAll: aCollection put: anObject .
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: indexArray putAll: valueArray
	
	| result |
	result := contents atAll: indexArray putAll: valueArray.
	self contentsChanged: valueArray.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAllPut: anObject 
	
	| result |
	result := contents atAllPut: anObject.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atLast: indexFromEnd put: obj
	
	| result |
	result := contents atLast: indexFromEnd put: obj.
	self contentsChanged: obj.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atWrap: index put: value
	
	| result |
	result := contents atWrap: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'private' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
insert: anObject before: spot

	| result |
	result := contents insert: anObject before: spot.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| result |
	result := contents remove: oldObject ifAbsent: absentBlock.
	self contentsChanged: oldObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAll

	contents removeAll.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAt: index

	| result |
	result := contents removeAt: index.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst

	| result |
	result := contents removeFirst.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst: n 

	| result |
	result := contents removeFirst: n .
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeIndex: removedIndex

	| result |
	result := contents removeIndex: removedIndex.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast

	| result |
	result := contents removeLast.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast: n

	| result |
	result := contents removeLast: n.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replace: aBlock 

	contents replace: aBlock .
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replaceAll: oldObject with: newObject 

	contents replaceAll: oldObject with: newObject .
	self contentsChanged: oldObject! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	contents reset.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
resetTo: index

	contents resetTo: index.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
sort: aSortBlock 

	contents sort: aSortBlock .
	self contentsChanged! !

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DictionaryValueHolder commentStamp: '<historical>' prior: 0!
A DictionaryValueHolder is a value holder designed for dictionaries!

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:29'!
at: key ifAbsentPut: aBlock 

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key put: value

	contents at: key put: value.
	self contentsChanged: value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged: anObject.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: ''!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue to: newValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: newValue)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedDo: aBlock

	| block |
	block := [:announcement :ann | aBlock cull: announcement newContents cull: announcement oldContents cull: announcement cull: ann ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: ''!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ NewValueHolder contents: self! !

!Object methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 6/18/2012 05:26'!
isSpecLayout

	^ false! !

Object subclass: #SpecBinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder commentStamp: '<historical>' prior: 0!
A SpecBinder is a stupid dictionary where keys are spec symbolic name and values are corresponding spec class!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/27/2012 09:59'!
initialize

	self initializeBindings! !

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 03:40'!
initializeBindings
	"self initializeBindings"
	bindings := IdentityDictionary new.
	bindings
		at: #ListSpec put: ListSpec;
		at: #MultiColumnListSpec put: MultiColumnListSpec;
		at: #IconListSpec put: IconListSpec;
		at: #RawSpec put: RawSpec;
		at: #ComposableSpec put: ComposableSpec;
		at: #TextSpec put: TextSpec;
		at: #ButtonSpec put: ButtonSpec;
		at: #CheckboxSpec put: CheckboxSpec;
		at: #DropListSpec put: DropListSpec;
		at: #LabelSpec put: LabelSpec;
		at: #TextFieldSpec put: TextFieldSpec;
		at: #TreeSpec put: TreeSpec.! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:55'!
specFor: aSymbol

	^ bindings at: aSymbol ! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:56'!
specFor: aSymbol ifAbsent: aBlock

	^ bindings at: aSymbol ifAbsent: aBlock! !

!SpecBinder methodsFor: 'see class side' stamp: 'BenjaminVanRyseghem 4/24/2012 03:37'!
seeClassSide! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'model spec superSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
A SpecInterpreter is a interpreter for spec presenters!

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
interpretASpec: aSpec model: aModel
	
	^ self new
		interpretASpec: aSpec
		model: aModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:25'!
interpretASpec: aPresenter model: aModel superSpec: aSpec
	
	^ self new
		interpretASpec: aPresenter
		model: aModel
		superSpec: aSpec! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
actionToPerformWithSelector: selector arguments: args
	^ spec instance perform: selector withArguments: args! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
bindings
	
	^ model bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: aComposableModel defaultSpecSelector! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
convertSymbolOfClassToInstance: aSymbol
	| symbol |
	
	symbol := self retrieveClassSymbolFor: aSymbol.
	
	^ (Smalltalk 
		at: symbol
		ifAbsent: [ ^ aSymbol ]) new! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/18/2012 05:26'!
interpretASpec: aPresenter
	| index anArray specToProvide |

	aPresenter ifNil: [ ^ nil ].
	
	anArray := aPresenter.
	aPresenter isSpecLayout ifTrue: [ anArray := aPresenter asArray ].
	
	(anArray isCollection and: [anArray isSequenceable]) ifFalse: [ ^ anArray ].
	(aPresenter isString or: [ aPresenter isText ]) ifTrue: [ 
			^ aPresenter == #model
				ifTrue: [ model ]
				ifFalse: [ self convertSymbolOfClassToInstance: aPresenter ]].

	" aPresenter is an Array "
	"First element is a symbol describing the spec type"
	spec := self retreiveSpecFrom: anArray first.
	spec class = RawSpec 
		ifTrue: [ specToProvide := superSpec ]
		ifFalse: [ specToProvide := spec ].
	spec addAsSubSpecTo: superSpec.
	index := 2.	
	
	[ index <= anArray size ]
		whileTrue: [ | selector numArgs args newInstance |
			selector := spec bindings retrieveSelectorSymbolFor: (anArray at: index).
			selector isArray not
				ifTrue: [ 
					selector := selector asSymbol.
					numArgs := selector numArgs.
					args := anArray copyFrom: index + 1 to: index + numArgs ]
				ifFalse: [| array |
					"Here I assume that if it's not a symbol, it's a collection"
					array := selector.
					selector := array first.
					numArgs := 0.
					args := array allButFirst ].
				args := args collect: [:each | self class interpretASpec: each model: model superSpec: specToProvide ].
				index := index + numArgs + 1.
				newInstance := self actionToPerformWithSelector: selector arguments: args.
			index > anArray size
				ifTrue: [
					| result |
					(model respondsTo: #spec:)
						ifTrue: [ model spec: spec ].
					result := self class interpretASpec: newInstance model: spec instance superSpec: specToProvide.
					(result isKindOf: ComposableModel)
						ifTrue: [| return | 
							return := result buildWithSpec.
							result spec addAsSubSpecTo: superSpec.
							^ return ]
						ifFalse: [ ^ result ]].
			spec instance: newInstance ].
			
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: (anArray size < 2).
	^ spec instance! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
interpretASpec: aPresenter model: aModel
	
	^ self interpretASpec: aPresenter model: aModel superSpec: NullObjectSpec new! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 19:24'!
interpretASpec: aPresenter model: aModel superSpec: aSpec
	
	self model: aModel.
	superSpec := aSpec.
	^ self interpretASpec: aPresenter! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
model
	^ model! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
model: anObject
	model := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 19:24'!
retreiveSpecFrom: aSymbol
	| instance aSpec |
	aSpec := ComposableSpec new.
	self class interpretASpec: aSymbol model: model superSpec: aSpec.
	aSpec subSpecs do: [:sub |
		sub addAsSubSpecTo: superSpec  ].
	instance :=  (SpecBinder 
			specFor: aSymbol 
			ifAbsent: [ ^ RawSpec new
							bindings: self bindings;
							defaultReceiver: aSymbol 
							model: model ]) new.
	^ instance 
		bindings: model bindings;
		yourself! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
retrieveClassSymbolFor: aSymbol

	^ self bindings retrieveClassSymbolFor: aSymbol! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents

	^ newContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents

	^ oldContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents: anObject
	
	oldContents := anObject! !
SpecBinder initialize!
